Utils.insertCSS ".dimmed {opacity: 0.4;}"

## GRID ##
grid.props =
	image: "images/gridlines.png"
	style:
		backgroundPosition: "0px 0px"
		backgroundRepeat: "repeat"
		backgroundSize: "auto"


## LAYER DRAGGABLE + SCALED VERSION ##
theLayer.draggable.enabled = yes

initialFrame = theLayer.frame

scaledLayer = new Layer
	frame: theLayer.frame
	parent: grid

theLayer.placeBefore scaledLayer

## HORIZONTAL TAGS ##
minXtag = new Layer
midXtag = new Layer
maxXtag = new Layer

for tag in [minXtag, midXtag, maxXtag]
	tag.props =
		width: 50
		height: 35
		backgroundColor: null
		color: "black"
		parent: grid
		borderColor: "#7DDD11"
		borderWidth:
			left: 2
		style:
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "12px"
			lineHeight: "30px"
			borderLeftWidth: "2px"
			paddingLeft: "20px"
	
	tag.states.hidden =
		opacity: 0

midXline = new Layer
	width: 1
	height: theLayer.height - 12
	backgroundColor: null
	x: theLayer.midX - 1
	y: theLayer.y + 6
	borderColor: "white"
	opacity: .7
	parent: grid
	borderWidth:
		left: 1

midXline.states.hidden =
	opacity: 0

## VERTICAL TAGS ##
minYtag = new Layer
midYtag = new Layer
maxYtag = new Layer

for tag in [minYtag,midYtag,maxYtag]
	tag.props =
		width: 70
		height: 35
		borderColor: "#7DDD11"
		borderWidth:
			top: 2
		color: "black"
		backgroundColor: null
		parent: grid
		style:
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "12px"
			lineHeight: "30px"
			paddingTop: "12px"
			paddingLeft: "10px"
	
	tag.states.hidden =
		opacity: 0

midYline = new Layer
	width: theLayer.width - 24
	height: 2
	borderColor: "white"
	borderWidth:
		top: 1
	x: theLayer.x + 12
	y: theLayer.midY - 2
	opacity: .7
	backgroundColor: null
	parent: grid

midYline.states.hidden =
	opacity: 0

## SLIDER LABELS + SLIDERS + SLIDER VALUES ##
labelWidthSlider = new Layer
	html: "<span class=\"dimmed\">layer.</span>width"

widthSlider = new SliderComponent 
	min: 0
	max: 250

widthSlider.onValueChange -> 
	theLayer.width = this.value

valueWidthSlider = new Layer
	html: theLayer.width


labelHeightSlider = new Layer
	html: "<span class=\"dimmed\">layer.</span>height"

heightSlider = new SliderComponent 
	min: 0
	max: 250

heightSlider.onValueChange -> 
	theLayer.height = this.value	

valueHeightSlider = new Layer
	y: 490 + 50
	html: theLayer.height


labelXSlider = new Layer
	html: "<span class=\"dimmed\">layer.</span>x"

xSlider = new SliderComponent 
	min: 0
	max: 500

xSlider.onValueChange -> 
	theLayer.x = this.value

valueXSlider = new Layer
	html: theLayer.x


labelYSlider = new Layer
	html: "<span class=\"dimmed\">layer.</span>y"

ySlider = new SliderComponent 
	min: 0
	max: 500

ySlider.onValueChange -> 
	theLayer.y = this.value

valueYSlider = new Layer
	html: theLayer.y



labelScaleSlider = new Layer
	html: "<span class=\"dimmed\">layer.</span>scale"

scaleSlider = new SliderComponent 
	min: 0
	max: 2

scaleSlider.onValueChange -> 
	scaledLayer.scale = this.value

valueScaleSlider = new Layer
	html: theLayer.scale



allLabels = [labelWidthSlider,labelHeightSlider,labelXSlider,labelYSlider,labelScaleSlider]
allSliders = [widthSlider,heightSlider,xSlider,ySlider,scaleSlider]
allValues = [valueWidthSlider,valueHeightSlider,valueXSlider,valueYSlider,valueScaleSlider]

# Loop over all sliders, their labels, and values
for i in [0..4]
	
	# Labels
	allLabels[i].props =
		width: 150
		height: 70
		backgroundColor: null
		x: 50
		y: grid.maxY + 50 + (i*50)
		style:
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "19px"
			lineHeight: "25px"

	# Sliders
	allSliders[i].props =
		width: 460
		height: 5
		x: allLabels[i].maxX + 10
		y: grid.maxY + 55 + (i*50)

	allSliders[i].fill.backgroundColor = "rgba(255,255,255,0.7)"
	allSliders[i].knobSize = 25
	allSliders[i].knob.borderRadius = 12.5
	allSliders[i].knob.backgroundColor = "rgba(255,255,255,1)"
	allSliders[i].backgroundColor = "rgba(255,255,255,0.3)"
	
	# Values
	allValues[i].props =
		width: 50
		height: 25
		backgroundColor: null
		x: allSliders[i].maxX + 20
		y: grid.maxY + 50 + (i*50)
		style: 
			fontFamily: "Menlo,Monaco,Courier,monospace"
			fontSize: "19px"
			lineHeight: "25px"

## BUTTONS ##
button_centerX = new Layer
	html: "<span class=\"dimmed\">layer.</span>centerX()"

button_centerX.onTapStart ->
	@backgroundColor = "rgba(153,153,153,1)"
button_centerX.onTap ->
	@backgroundColor = "white"
	theLayer.animate
		x: Align.center

button_centerY = new Layer
	html: "<span class=\"dimmed\">layer.</span>centerY()"

button_centerY.onTapStart ->
	@backgroundColor = "rgba(153,153,153,1)"
button_centerY.onTap ->
	@backgroundColor = "white"
	theLayer.animate
		y: Align.center

button_center = new Layer
	html: "<span class=\"dimmed\">layer.</span>center()"

button_center.onTapStart ->
	@backgroundColor = "rgba(153,153,153,1)"
button_center.onTap ->
	@backgroundColor = "white"
	theLayer.animate
		x: Align.center
		y: Align.center

button_reset = new Layer
	html: "Reset layer"

button_reset.onTapStart ->
	@backgroundColor = "rgba(153,153,153,1)"
button_reset.onTap ->
	@backgroundColor = "white"
	theLayer.animate
		width: initialFrame.width
		height: initialFrame.height
		x: initialFrame.x
		y: initialFrame.y
	scaledLayer.animate
		scale: 1

for button, i in [button_centerX,button_centerY,button_center,button_reset]
	button.width = 200
	button.height = 40
	button.backgroundColor = "white"
	button.x = Screen.width - 200 - 45 # grid.maxX - 400
	button.y = grid.maxY + 37 + (i*60)
	button.borderRadius = 25
	button.color = "black"
	button.style =
		fontFamily: "Menlo,Monaco,Courier,monospace"
		fontSize: "18px"
		lineHeight: "80px"
		textAlign: "center"

button_reset.style =
	fontFamily: Title.fontFamily
	fontWeight: 300
	fontSize: "22px"
	lineHeight: "74px"
button_reset.y = button_center.maxY + 35

# triggered on X, Y, Width, Height and Scale change events
setLayerDetails = (thislayer) ->
	# sliders
	widthSlider.value = thislayer.width
	heightSlider.value = thislayer.height
	xSlider.value = thislayer.x
	ySlider.value = thislayer.y
	scaleSlider.value = scaledLayer.scale
	
	# value readings
	valueWidthSlider.html = "#{Utils.round thislayer.width}"
	valueHeightSlider.html = "#{Utils.round thislayer.height}"
	valueXSlider.html = "#{Utils.round thislayer.x}"
	valueYSlider.html = "#{Utils.round thislayer.y}"
	valueScaleSlider.html = "#{Utils.round scaledLayer.scale, 2}"
	
	# reset tags
	minXtag.visible = yes
	midXtag.visible = yes
	midXline.visible = yes
	maxXtag.visible = yes
	minYtag.visible = yes
	midYtag.visible = yes
	midYline.visible = yes
	maxYtag.visible = yes
	
	# horizontal tags
	minXtag.x = thislayer.x - 1.5
	minXtag.y = thislayer.y - 41
	minXtag.html = "minX<br>#{Utils.round thislayer.x}"
	
	midXtag.x = thislayer.midX - 1.5
	midXtag.y = thislayer.y - 41
	midXtag.html = "midX<br>#{Utils.round thislayer.midX}"
	
	midXline.height = thislayer.height - 12
	midXline.x = thislayer.midX - 1
	midXline.y = thislayer.y + 6
	
	maxXtag.x = thislayer.maxX - 1.5
	maxXtag.y = thislayer.y - 41
	maxXtag.html = "maxX<br>#{Utils.round thislayer.maxX}"
	
	if thislayer.width < 0.5
		minYtag.visible = no
		midYtag.visible = no
		midYline.visible = no
		maxYtag.visible = no
	if thislayer.width < 20
		midXline.visible = no
	if thislayer.width < 40
		minXtag.visible = no
		maxXtag.visible = no
	if thislayer.width < 80
		midXtag.visible = no
	
	# vertical tags
	minYtag.x = thislayer.maxX + 5
	minYtag.y = thislayer.y - 1.5
	minYtag.html = "minY #{Utils.round thislayer.y}"
	
	midYtag.x = thislayer.maxX + 5
	midYtag.y = thislayer.midY - 1.5
	midYtag.html = "midY #{Utils.round thislayer.midY}"
	
	midYline.width = theLayer.width - 24
	midYline.x = theLayer.x + 12
	midYline.y = theLayer.midY - 1
	
	maxYtag.x = thislayer.maxX + 5
	maxYtag.y = thislayer.maxY - 1.5
	maxYtag.html = "maxY #{Utils.round thislayer.maxY}"
	
	if thislayer.height < 15
		midYline.visible = no
	if thislayer.height < 25
		minYtag.visible = no
		maxYtag.visible = no
	if thislayer.height < 40
		midYtag.visible = no


theLayer.on "change:width", ->
	reset_timer()
	setLayerDetails this

theLayer.on "change:height", ->
	reset_timer()
	setLayerDetails this

theLayer.on "change:x", ->
	reset_timer()
	setLayerDetails this

theLayer.on "change:y", ->
	reset_timer()
	setLayerDetails this

scaledLayer.on "change:scale", ->
	reset_timer()
	setLayerDetails this

# Showing and hiding the markers
hideMarkers = ->
	minXtag.animate "hidden"
	midXtag.animate "hidden"
	midXline.animate "hidden"
	maxXtag.animate "hidden"
	minYtag.animate "hidden"
	midYtag.animate "hidden"
	midYline.animate "hidden"
	maxYtag.animate "hidden"

showMarkers = ->
	minXtag.stateSwitch "default"
	midXtag.stateSwitch "default"
	midXline.stateSwitch "default"
	maxXtag.stateSwitch "default"
	minYtag.stateSwitch "default"
	midYtag.stateSwitch "default"
	midYline.stateSwitch "default"
	maxYtag.stateSwitch "default"

timer = 0
load_timer = ->
	timer = setTimeout ( ->
		hideMarkers()
), 5000

reset_timer = ->
	showMarkers()
	scaledLayer.frame = theLayer.frame
	clearTimeout timer	# cancel the timer
	load_timer()		# and restart it

# After loading
widthSlider.value = theLayer.width
heightSlider.value = theLayer.height
xSlider.value = theLayer.x
ySlider.value = theLayer.y
scaleSlider.value = theLayer.scale

reset_timer()
setLayerDetails theLayer
